{ Invokable interface IMyDictService }

unit MyDictServiceIntf;

interface

uses InvokeRegistry, Types, XSBuiltIns;

type
  TGroup = class(TRemotable)
  private
    fID:integer;
    fGroup:AnsiString;
  published
    property id:integer read fID write fID;
    property group:AnsiString read fGroup write fGroup;
  end;

  TExpression = class(TRemotable)
  private
    fID:integer;
    fGID:integer;
    fValue:AnsiString;
    fLang:String;
  published
    property id:integer read fID write fID;
    property gid:integer read fGID write fGID;
    property lang:string read fLang write fLang;
    property value:AnsiString read fValue write fValue;
  end;

  TArrayOfAnsiString = array of AnsiString;
  TArrayOfGroup = array of TGroup;
  TArrayOfExpression = array of TExpression;

  { Invokable interfaces must derive from IInvokable }
  IMyDictService = interface(IInvokable)
  ['{586FA768-01B9-4EBE-A766-F2AF8F57F737}']
    { Methods of Invokable interface must not use the default }
    function addGroup(name:WideString):TGroup;stdcall;
    function modifyGroup(id:integer;name:WideString):TGroup;stdcall;
    function addExpression(id:integer;lang:string;gid:integer;expression:WideString):TExpression;stdcall;
    function modifyExpression(id:integer;lang:string;gid:integer;expression:WideString):TExpression;stdcall;
    function getGroups():TArrayOfGroup;stdcall;
    function getWordById(id:integer; lang: string):TExpression;stdcall;
    function getWordsByGroupId(gid:integer; lang: string):TArrayOfExpression;stdcall;
    function deleteWord(id:integer; lang: string):boolean;stdcall;
  end;

implementation

initialization
  { Invokable interfaces must be registered }
  InvRegistry.RegisterInterface(TypeInfo(IMyDictService));

end.
 